/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.system.action;

import jp.mosp.common.MosPAction;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.common.MospUtility;
import jp.mosp.system.dao.MSyozokuDao;
import jp.mosp.system.dto.MSyozokuDto;
import jp.mosp.system.vo.SyozokuMasterCardVo;

public class SyozokuMasterCardAction extends MosPAction {

	// コマンド
	private static final String CMD_SYOZOKU_CARD_SHOW   = "S2105";	// 表示(追加)
	private static final String CMD_SYOZOKU_CARD_SELECT = "S2106";	// 表示(選択)
	private static final String CMD_SYOZOKU_CARD_INSERT = "S2107";	// 登録
	private static final String CMD_SYOZOKU_CARD_UPDATE = "S2108";	// 更新
	private static final String CMD_SYOZOKU_CARD_DELETE = "S2109";	// 削除

	/**
	 * コンストラクタ
	 */
	public SyozokuMasterCardAction() {
		super();
	}

	/**
	 * アクション
	 */
	public void action() throws Exception {
		// DBコネクション取得
		getConnection();
		// SYSTEM権限確認
		confirmSystemAuth();
		// VOの取得及び設定		
		SyozokuMasterCardVo vo = new SyozokuMasterCardVo();
		vo.initVo(cfg, msg, cmd, aspUser, user);
		vo.setParams(request);
		// VO及びフォワード先URLの設定
		setVo(vo);
		setUrl(vo.getRetUrl());
		// DAOの準備
		MSyozokuDao dao = new MSyozokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// DTOの取得
		MSyozokuDto dto;
		Object obj = session.getAttribute(MospConst.ATT_DTO);
		dto = obj instanceof MSyozokuDto ? (MSyozokuDto)obj : null;
		// コマンド毎の処理
		if (cmd.equals(CMD_SYOZOKU_CARD_SHOW)) {
			//表示(新規)
			vo.setTxtSCode1("");
			vo.setTxtSCode2("");
			vo.setTxtSCode3("");
			vo.setTxtSName("");
			vo.setMode(SyozokuMasterCardVo.MODE_INSERT);
		} else if (cmd.equals(CMD_SYOZOKU_CARD_SELECT)) {
			// 表示(キーで情報を検索)
			// データの取得
			dto = dao.findForKey(key1);
			chkExist(dto);
			// VOに情報をセット
			vo.setFields(dto);
			setMode(vo);
			//セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else if (cmd.equals(CMD_SYOZOKU_CARD_INSERT)) {
			//新規登録
			dto = insert(vo);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else if (cmd.equals(CMD_SYOZOKU_CARD_UPDATE)) {
			// 更新
			dto = update(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);			
		} else if (cmd.equals(CMD_SYOZOKU_CARD_DELETE)) {
			// 削除
			delete(vo, dto);
			// セッションにDTOをセット
			session.setAttribute(MospConst.ATT_DTO, dto);
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}

	/**
	 * データ挿入
	 * @param vo 対象VO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MSyozokuDto insert(SyozokuMasterCardVo vo) throws Exception {
		//パラメーターの妥当性確認
		vo.validate(true);
		//DAOの準備
		MSyozokuDao dao = new MSyozokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		//存在チェック
		chkDuplicate(dao.findForKey(vo.getTxtSCode1() + vo.getTxtSCode2() + vo.getTxtSCode3()), vo);
		//DTOの準備
		MSyozokuDto dto = new MSyozokuDto();
		vo.setDtoFields(dto);
		//データの挿入
		dao.insert(dto);
		//DTOの再取得
		dto = dao.findForKey(dto.getSCode());
		chkInsert(dto);
		//コミット
		commit();
		//モード設定
		setMode(vo);
		//メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_INSERT, ""));
		return dto;			
	}

	/**
	 * データ更新
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @return データ挿入対象DTO
	 * @throws Exception
	 */
	private MSyozokuDto update(SyozokuMasterCardVo vo, MSyozokuDto dto) throws Exception {
		// パラメータの妥当性確認
		vo.validate(false);
		// DAOの準備
		MSyozokuDao dao = new MSyozokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		// 排他確認
		chkExclusive(dto, dao.findForUpdate(vo.getTxtSCode1() + vo.getTxtSCode2() + vo.getTxtSCode3()), vo);
		// DTOの準備
		vo.setDtoFields(dto);
		// データの更新
		dao.update(dto);
		// DTOの再取得
		MSyozokuDto retDto = dao.findForKey(dto.getSCode());
		chkUpdate(retDto);
		// コミット
		commit();
		// モード設定
		setMode(vo);
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_UPDATE, ""));
		return retDto;		
	}

	/**
	 * データ削除
	 * @param vo 対象VO
	 * @param dto 対象DTO
	 * @throws Exception
	 */
	private void delete(SyozokuMasterCardVo vo, MSyozokuDto dto) throws Exception {
		// DAOの準備
		MSyozokuDao dao = new MSyozokuDao();
		dao.initDao(cfg, cmd, aspUser, user, conn);
		vo.setDtoFields(dto);
		// データの更新
		dao.delete(dto);
		// コミット
		commit();		
		// メッセージ設定
		vo.setMessage(MospUtility.getMessage(msg, MospConst.MSG_DELETE, ""));
	}

	/**
	 * モード設定
	 * @param vo 対象VO
	 * @throws Exception
	 */
	private void setMode(SyozokuMasterCardVo vo) throws Exception {
		// モード設定
		if (hasSystemAuth()) {
			vo.setMode(SyozokuMasterCardVo.MODE_SYSTEM);
		} else {
			vo.setMode(SyozokuMasterCardVo.MODE_UPDATE);
		}
	}

}
